DECLARE SUB intervall (xa0!, xe0!, xfix!)
DIM SHARED a, m
'-----------------------------------------------------
'Programm FIXPKT1.BAS
'-----------------------------------------------------
'Numerische Berechnung von Fixpunkten der
'm-ten Iterierten von x(n+1) = x(n)^2 + a
'mittels Intervallschachtelung
'-----------------------------------------------------
'Eingabewerte:
a = -1.76              'Parameter a
m = 3                  'm-te Iterierte
xmin = -2              'Gesamtintervall [xmin, xmax]
xmax = 2
k = 20                 'Anzahl der Teilintervalle k
'-----------------------------------------------------

CLS

PRINT "Fixpunktsuche "; m; "-te Iteration, a = "; a
PRINT "Intervall               Fixpunkt"
PRINT "--------------------------------------------"

xa0 = xmin
xe0 = xmin + (xmax - xmin) / k
CALL intervall(xa0, xe0, xfix)
PRINT USING "[##.### , ##.###]     ###.######"; xa0; xe0; xfix

FOR i = 1 TO k - 1
   xa0 = xe0
   xe0 = xa0 + (xmax - xmin) / k
   CALL intervall(xa0, xe0, xfix)
   PRINT USING "[##.### , ##.###]     ###.######"; xa0; xe0; xfix
NEXT i

END

SUB intervall (xa0, xe0, xfix)

xa = xa0                        'Intervall
xe = xe0
schritt = (xe - xa) / 100       'Schrittweite

DO                              'Intervallschleife
   y1 = xa ^ 2 + a              'Anfangswerte
   FOR i = 1 TO m - 1
     y1 = y1 ^ 2 + a
   NEXT i
   y2 = xa
   s2 = SGN(y1 - y2)
   j = 0

   DO                           'Schnittpunktbestimmung
      s1 = s2
      y1 = xa ^ 2 + a
      FOR i = 1 TO m - 1        'm-te Iterierte
         y1 = y1 ^ 2 + a
      NEXT i
      y2 = xa
      xa = xa + schritt
      s2 = SGN(y1 - y2)
      j = j + 1
      IF j > 100000 THEN        'Abbruchbedingung der
         xfix = 0               'inneren Schleife
         EXIT SUB
      END IF
   LOOP UNTIL s1 <> s2          'Schnittpunktbedingung

   xa = xa - 2 * schritt
   xe = xa + schritt
   schritt = (xe - xa) / 100
LOOP UNTIL schritt < .0000001   'Rechengenauigkeit

IF xa < xa0 OR xe > xe0 THEN    'Prozedurergebnis
   xfix = 0
ELSE
   xfix = (xa + xe) / 2
END IF

END SUB

