'--------------------------------------------------------
'Quellprogramm: JULIA1.BAS
'--------------------------------------------------------
'Berechnung der Julia-Menge mit
'Umkehriteration z(n+1) = +-SQR (z(n)- c)
'--------------------------------------------------------
'Eingabewerte:
a = -1: b = 0            'Parameter c = (a,b)
x = -.1: y = 0           'Startwert z0 = (x0, y0)
nmax = 100000            'Anzahl der Iterationen nmax
'--------------------------------------------------------

SCREEN 12                        'VGA, 640 x 480 Pixel, 16 Farben
px = 420: py = 420               'Bildschirmbereich

'z -Ebene                        'mathematischer Bereich
xmin = -2: xmax = 2              'Realteil
ymin = -2: ymax = 2              'Imaginaerteil

xschritt = (xmax - xmin) / px    'Schrittweite
yschritt = (ymax - ymin) / py


'Achsenkreuz
LINE (0, ymax / yschritt)-(px, ymax / yschritt)
LINE (-xmin / xschritt, 0)-(-xmin / xschritt, py)

'Einheitskreis
CIRCLE (-xmin / xschritt, ymax / yschritt), 1 / xschritt

'Iterationsschleife
FOR i = 1 TO nmax
   p = x - a: q = y - b
   IF q = 0 THEN
     IF p <= 0 THEN
       u = 0: v = SQR(-p)
     ELSE
       u = SQR(p): v = 0
     END IF
   ELSE
      u = SQR((p + SQR(p ^ 2 + q ^ 2)) / 2)
      IF u = 0 THEN v = SQR(-p) ELSE v = q / 2 / u
   END IF
   x = u: y = v
   'zufaellige Auswahl der beiden Wurzeln
   IF RND > .5 THEN x = -x: y = -y
   'Punktausgabe                              
   IF i > 50 THEN
      sx = (x - xmin) / xschritt
      zy = (ymax - y) / yschritt
      PSET (sx, zy), 12
   END IF
NEXT i

PRINT "c-Parameter:"
PRINT "("; a; ","; b; ")"

END


